from cryptography.exceptions import *
from cryptography.hazmat.primitives.asymmetric import rsa
from cryptography.hazmat.primitives import hashes
from cryptography.hazmat.primitives.asymmetric import padding
from cryptography.hazmat.primitives import serialization

class Signature:
    def generate_keys():
        private_key = rsa.generate_private_key(public_exponent=65537,key_size=2048)
        public_key = private_key.public_key()

        return private_key, public_key
    
    def keys_to_bytes(private_key, public_key):
        prv_ser = private_key.private_bytes(
            encoding=serialization.Encoding.PEM,
            format=serialization.PrivateFormat.TraditionalOpenSSL,
            encryption_algorithm=serialization.NoEncryption())
        
        pbc_ser = public_key.public_bytes(
            encoding=serialization.Encoding.PEM,
            format=serialization.PublicFormat.SubjectPublicKeyInfo)
        
        return prv_ser, pbc_ser
    
    def bytes_to_keys(private_ser, public_ser):
        private_key = serialization.load_pem_private_key(
            private_ser,
            password=None
        )
        public_key = serialization.load_pem_public_key(
            public_ser
        )
        return private_key, public_key